/*******************************************************************************
 * Copyright (c) 2000, 2004 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.target.internal.ide.ui;

import java.net.URL;

import org.eclipse.core.resources.IResource;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.target.internal.TargetPlugin;
import org.eclipse.target.internal.ide.*;
import org.eclipse.target.internal.ide.IdeTargetResource;
import org.eclipse.target.internal.ide.IdeWorkspaceSite;
import org.eclipse.target.internal.ui.SiteElement;
import org.eclipse.ui.model.IWorkbenchAdapter;

/**
 * Override SiteElement in order to provide proper images to
 * IResource target resources
 */
public class IdeSiteElement extends SiteElement {

	/* (non-Javadoc)
	 * @see org.eclipse.target.internal.ui.TargetResourceElement#getImageDescriptor(java.lang.Object)
	 */
	public ImageDescriptor getImageDescriptor(Object object) {
		if (object instanceof IdeWorkspaceSite) {
			IResource resource = ((IdeTargetResource)((IdeWorkspaceSite)object).getRootResource()).getIResource();
			IWorkbenchAdapter adapter = (IWorkbenchAdapter)resource.getAdapter(IWorkbenchAdapter.class);
			ImageDescriptor imageDescriptor = adapter.getImageDescriptor(resource);
			if (imageDescriptor == null) {
				URL url = TargetIdePlugin.getDefault().getImageURL("wizards/ideicon_wiz.gif");
				imageDescriptor = TargetPlugin.getDefault().getImageDescriptor(url.toExternalForm(), url);
			}
			return imageDescriptor;
		}
		return super.getImageDescriptor(object);
	}
}
