/*******************************************************************************
 * Copyright (c) 2004 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.target.internal.iofile;

import org.eclipse.core.runtime.*;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * The main plugin class to be used in the desktop.
 */
public class IoFilePlugin extends AbstractUIPlugin {
	
	public static final String ID = "org.eclipse.target.iofile"; //$NON-NLS-1$
	public static final String SITE_TYPE_ID = ID + ".site";  //$NON-NLS-1$
	
	//The shared instance.
	private static IoFilePlugin plugin;

	
	/**
	 * The constructor.
	 */
	public IoFilePlugin() {
		plugin = this;
	}

	/**
	 * This method is called upon plug-in activation
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		Policy.localize("org.eclipse.target.internal.iofile.messages"); //$NON-NLS-1$
	}

	/**
	 * This method is called when the plug-in is stopped
	 */
	public void stop(BundleContext context) throws Exception {
		super.stop(context);
	}

	/**
	 * Returns the shared instance.
	 */
	public static IoFilePlugin getDefault() {
		return plugin;
	}

	public static CoreException wrapException(Exception e) {
		return new CoreException(new Status(IStatus.ERROR, ID, 0, e.getMessage() != null ? e.getMessage() : "",	e)); //$NON-NLS-1$
	}

	public static void log(CoreException e) {
		log (e.getMessage(), e);
	}

	public static void log(String string, CoreException e) {
		getDefault().getLog().log(new Status(e.getStatus().getCode(), ID, 0, string, e));
	}
}
